// z80 Assembly Header Generator
// (c) 2003 Sonic Studios
// Written by silent_fury
//
// Automatically generates a header for a z80 or asm file.
// Saves user the trouble of either copying and pasting a header in
// or typing it all out.  User has choice of a nostub(tios), Ion, or
// MirageOS header.  MirageOS requires "button" data to be entered
// directly into asm file; this does no touch it except to put, "IMAGE
// DATA HERE..."

program asm_header(input, output, f);

var c:integer;							//	holds user selection
	i:integer;							//	loop counter var
	f:text;								//	txt file...
	name:string;						//	name for txt file
//__________________________________________________________________________
procedure get_type;
begin
writeln('z80 Header Generator v1.0');
writeln('-------------------------');
writeln;
writeln('What shell do you want the header conformed to?');
writeln;
writeln('1: Nostub (TI-OS)');
writeln('2: Ion or Ion compatible');
writeln('3: MirageOS');
writeln('4: Never Mind... (Exit)');
writeln;
c:=0;									//	initialize c

repeat 									//	error trap answer
write('Enter your choice: ');
readln(c);
until (c>0) and (c<5);
end;
//__________________________________________________________________________
procedure getname;
begin
writeln;
write('Enter the file name (including extension!): ');
readln(name);
assign(f, name);
rewrite(f);
end;
//__________________________________________________________________________
procedure nostub;
begin
writeln(f,' ');
writeln(f,'.NOLIST');
writeln(f,'#define     equ             .equ');
writeln(f,'#define     EQU             .equ');
writeln(f,'#define     END             .end');
writeln(f,'#include "ti83plus.inc"');
writeln(f,'.LIST');
writeln(f,'');
writeln(f,'#define bcall(xxxx)     rst 28h    \ .dw xxxx');
writeln(f,'#define bcallz(xxxx)    jr nz,$+5  \ rst 28h  \ .dw xxxx');
writeln(f,'#define bcallnz(xxxx)   jr  z,$+5  \ rst 28h  \ .dw xxxx');
writeln(f,'#define bcallc(xxxx)    jr  nc,$+5 \ rst 28h  \ .dw xxxx');
writeln(f,'#define bcallnc(xxxx)   jr  c,$+5  \ rst 28h  \ .dw xxxx');
writeln(f,'#define bjump(xxxx)     call 50h   \ .dw xxxx');
writeln(f,' ');
writeln(f,'		.org        9D93h');
writeln(f,' ');
writeln(f,' ');
writeln(f,'start:');
writeln(f,'  ');
close(f);
end;
//__________________________________________________________________________
procedure ion;
begin
writeln(f,'.nolist');
writeln(f,'#include "ion.inc"');
writeln(f,'.list');
writeln(f,'#ifdef TI83P');
writeln(f,'  .org    progstart-2');
writeln(f,'  .db     $BB,$6D');
writeln(f,'#else');
writeln(f,'  .org    progstart');
writeln(f,'#endif');
writeln(f,'  ret');
writeln(f,'  jr      nc,start');
writeln(f,'  .db     "description",0');
writeln(f,' ');
writeln(f,'start:');
writeln(f,'  ');
close(f);
end;
//__________________________________________________________________________
procedure mirage;
begin
writeln(f,'#include "ti83plus.inc"          ;General TI-83 Plus include file');
writeln(f,'#include	"mirage.inc"			;MirageOS include file');
writeln(f,' ');
writeln(f,'	.org	$9d93				;Origin (set back two to account for AsmPrgm)');
writeln(f,'	.db	$BB,$6D				;Compiled AsmPrgm token');
writeln(f,'	ret					;So TI-OS wont run it');
writeln(f,'	.db	1				;Identifier as MirageOS program');
writeln(f,'	;IMAGE DATA HERE...');
writeln(f,'	.db	"description",0	                ;Zero terminated description');
writeln(f,'	');
writeln(f,'Start:');
writeln(f,'  ');
close(f);
end;
//__________________________________________________________________________

begin
get_type;
if c<>4 then begin
getname;
writeln;
writeln('Creating file...');
case c of
	1:nostub;
	2:ion;
	3:mirage;
	end;
writeln('Done. Press Enter...');
readln;
end;
end.